#!/usr/bin/perl -w

use Time::HiRes qw(gettimeofday);
use POSIX ":sys_wait_h";
use Sys::Hostname;


$myhome="$ENV{HOME}/.xfbsuite";
$r="$myhome/results";
$tmpdir="$myhome/.tmp";
$hostname="Unknow";

print "Xfbsuite ver. 0.9.7.4\n";

if (! -d "$myhome") {mkdir "$myhome"}
if (! -d "$r") {mkdir "$r"}
if (! -d "$tmpdir") {mkdir "$tmpdir"}

@atext=("results", "$r/Cpu", "$r/Ram", "$r/Cache", "$r/Filesystem", "$r/Drive", "$r/2D");
foreach $i (@atext) {

   if(! -d "$i") { mkdir "$i"; }
}      


$hostname=hostname;
$username=$ENV{LOGNAME};
$bonniepath="/usr/bin/xfbsuite/bonnie++";
$nbench="/usr/bin/xfbsuite/nbench";
$stream="/usr/bin/xfbsuite/stream";
$cachebench="/usr/bin/xfbsuite/cachebench";
#$piozone="/usr/bin/xfbsuite/piozone";


sub usage {
print "Usage:\n -a (all Benchmarks)\n -d (Drive)\n -r (RAM)\n -f (Filesystem)\n -c (CPU)\n -l (L1/L2 Cache)\n -x (X11 2D)\n -h (help)\n";
exit(0);
}

&usage() if (scalar @ARGV == 0);

$a=@ARGV;
	
	if ( "$ARGV[0]" eq "--help" ) {
	   print "usage:\n -a (all Benchmarks)\n -d (Drive) (only root)\n -r (RAM)\n -f (Filesystem)\n -p (CPU)\n -l (L1/L2 Cache)\n -x (X11 2D)\n -c (Compare <para>)\n -h (help)\n";
	   exit 0;
	} elsif ( $ARGV[0] =~ /^-a$/ )  { &all;
	} elsif ($ARGV[0] =~ /^-d$/) { &hdbench;
	} elsif ($ARGV[0] =~ /^-b$/) { &hdd;
	} elsif ($ARGV[0] =~ /^-r$/) { &ram;
	} elsif ($ARGV[0] =~ /^-f$/) { &fs;
	} elsif ($ARGV[0] =~ /^-p$/) { &cpu;
	} elsif ($ARGV[0] =~ /^-l$/) { &cache;
	} elsif ($ARGV[0] =~ /^-x$/) { &x11;
	} elsif ($ARGV[0] =~ /^-c$/) { &compare( $ARGV[1] );
	} else { print "Unknown arg \n";
		 print "usage:\n -a (all Benchmarks)\n -d (Drive)\n -r (RAM)\n -f (Filesystem)\n -p (CPU)\n -l (L1/L2 Cache)\n -x (X11 2D)\n -c (Compare <para>\n -h (help)\n";
	         exit 0;
	}
	
	

	

sub getout {
print "User abort!\n";
exit 0;
}


################################################## Save ###############################################################

sub speichern {

$dir4 = "$myhome/results/$_[0]";

# ffnen des Verzeichnisses und die einzenlen Dateinamen in ein Array (@files) speichern:
 opendir(BIN, $dir4) or die "Can't open  $dir4\n";
   @f = readdir(BIN);
 close(BIN);
 
 @files = grep { !/^\.\.?$/ } @f;
 
# Falls vorhanden nur die Zahl nach dem "_" speichern: 
 $y=@files;

for ($i=0; $i<=$y-1; $i++) 
 {
 	$A = $files[$i];
	@bla = split (/_/, $A);
	$array[$i] = $bla[1];
  }


if (!defined $array[-1] ) { @array = ('0'); }

  $prefix = $array[-1]+1 ;


return $prefix;

}


################################################### Compare #############################################################

sub compare {

$dir4 = "$myhome/results/$_[0]";

 opendir(BIN, $dir4) or die "Can't open $dir4\n ";
   @f = readdir(BIN);
 close(BIN);
 
 @files = grep { !/^\.\.?$/ } @f;
 $zahl = @files;
 

for ( $i=0; $i<$zahl; $i++ ) 
  { 
        open(DATEN, "$dir4/$files[$i]") || die "Fehler2\n";
	@datei=<DATEN>;
	$c=@datei;
	chomp(@datei);
	$liste[$i] = \@datei;
   }


$puh=@liste;

print "\n"; 
$i=0;
for ($i=0; $i<$c; $i++) {
	for ($a=0; $a<$puh; $a++) { print "$liste[$a][$i]" }
	print "\n";
}
print "\n";

}

##################################################### Drive Benchmark (Own) #########################################################

sub hdbench {

#$username=$ENV{LOGNAME};


if ($username ne "root") { print "Error! you must be root for Raw HDD test\n"; exit 1 }

sub kilhd {
$SIG{INT} = \&kilnd;
print "User abort\n";
exit 0;
}


local $SIG{INT} = \&kilhd;
local $SIG{QUIT} = \&kilhd;


$gb=4;
$device="hda";

open(MODEL, "/proc/ide/$device/model") or die "Error!! Can't open file: /proc/ide/$device/model\n";
$model=<MODEL>;
close(MODEL);

chomp $model;
print "\nModel: $model";

sysopen(HDA,"/dev/hda",0) || die "Error!! Can't open /dev/hda!\n";
$hdasize=sysseek(HDA,0,2);
printf "\nDrivesize: %.2f GB\n\n",$hdasize/1024/1024/1024;

$hda=$hdasize/1024/1024/1024;

if ( $hda > 60 ) { $gb=7; }

$readbyte=60;
$read1024=1024*1024;
$read64=64*1024;


$prefix= &speichern("Drive");

$sfile="$myhome/results/Drive/$hostname $model\_$prefix";

print "\nRunning Drive Benchmark....\n";
print "\nresult: $sfile\n\n";


$sprung=$gb*1024*1024*1024;
$anzahl=int $hda/$gb;


open(RE, ">>$sfile") || die "Error!! Can't open Result file at: $file\n";

print RE "\n\t    $hostname:\t\n";
print RE "\t    $model\t\n\n";
print RE "\t    Linear MB/s\t\n";
print RE "\t    ----------\t\n";

close(RE);

&linear($read1024);
&linear($read64);


open(RE, ">>$sfile");
print RE "\t    Random MB/s\t\n";
print RE "\t    ----------\t\n";
close(RE);
   

#&random($read1024);
#&random($read64);



sub linear {

local $SIG{INT} = \&kilhd;

sysseek(HDA,0,0) || die "Can't seek to begin of this device!\n";

$bytes=$_[0];
$t2=0;
$gesamt=0;
$ge=0;

for ($a=0; $a<$anzahl; $a++)
 {
	$t0 = gettimeofday;
	
	if (eof(HDA)) { print "End of Device!\n"; exit 1;}
	
	while ( $ge<60 ) {
		if (eof(HDA)) { print "End of Device!\n"; exit 1;}
		sysread(HDA,$d,$bytes);
		$ge+=length($d)/1024/1024; 
	}
	$ge=0;
	$t2 = gettimeofday;
	$t3 = $t2 - $t0;
	
	$gbs[$a]=$readbyte/$t3;
        $gesamt+=$gbs[$a];
        printf "read 60 MB in %.2f Sec.= %.2f MB/s at offset %2.f GB - %2.f GB Used %2.f Kbyte\n",$t3,$gbs[$a],sysseek(HDA,0,1)/1024/1024/1024, $sprung/1024/1024/1024 + (sysseek(HDA,0,1)/1024/1024/1024), $bytes/1024;
	$z=sysseek(HDA,$sprung,1); 
  }
    
   $ge=0;
   @so = sort { $a <=> $b } @gbs;

   $Avg=($gesamt/$anzahl);

   $Min=$so[0];
   $Max=$so[-1];

   printf "\nMin: %.1f, Avg: %.1f, Max: %.1f\n\n",$Min,$Avg,$Max;
   open(RE, ">>$sfile");
   printf RE "\n\t     %.0f k:\t",$bytes/1024;
   print RE "\n\t   Min|Avg|Max\t\n\n";
   printf RE "\t%.1f | %.1f | %.1f\n\n",$Min,$Avg,$Max; 
   close(RE);

}



   
   
sub random {

sysseek(HDA,0,0);

$zufall=1048576000;
$ge=0;
$t2=0;
$gesamt=0;

$bytes=$_[0];

if ( $bytes == 65536 ) { $gb+=$gb; }

$anzahl=int $hda/$gb;
$sprung=$gb*1024*1024*1024;

 for ($a=0; $a<$anzahl; $a++)
 {
	$t0 = gettimeofday;
	$file=sysseek(HDA,0,1);
	
	printf "read 60 MB in %.2f Sec. = %.2f MB/s at offset %2.f GB - %2.f GB Used %2.f Kbyte\n",$t3,$gbs[$a],sysseek(HDA,0,1)/1024/1024/1024,$sprung/1024/1024/1024 + sysseek(HDA,0,1)/1024/1024/1024, $bytes/1024;
	
	while ($ge <=60) {
		
	$ran = int rand($zufall);
		
	sysseek(HDA,$ran,1); 
	sysread(HDA,$d,$bytes);
		
	$ge+=length($d)/1024/1024; 
	sysseek(HDA,$file,0);
	}
		
	$ge=0;
	$t2 = gettimeofday;
	$t3 = $t2 - $t0;
	
	$gbs[$a]=$readbyte/$t3;
        $gesamt+=$gbs[$a];
	
	
	$z=sysseek(HDA,$sprung,1);
  }
 
   $ge=0;
   @so = sort { $a <=> $b } @gbs;

   $Avg=($gesamt/$anzahl);

   $Min=$so[0];
   $Max=$so[-1];

   open(RE, ">>$sfile");	
   printf "\nMin: %.1f, Avg: %.1f, Max: %.1f\n\n",$Min,$Avg,$Max;
   printf RE "\n\t     %.0f k:\t",$bytes/1024;
   print RE "\n\t   Min|Avg|Max\t\n\n";
   printf RE "\t%.1f | %.1f | %.1f\n\n",$Min,$Avg,$Max; 
   
   close(RE);
   
}





close(HDA);

}
####################################################################################################################################





################################################ Drive Benchmark (Piozone)##########################################################

sub hdd {

sub kilpio {
$SIG{INT} = \&kilpio;
print "User abort\n";
kill 9, $retval;
exit 0;
}


local $SIG{INT} = \&kilpio;
local $SIG{QUIT} = \&kilpio;


$gb = 2;
$sec = 2;
$device = "hda";

open(FILE, "/proc/ide/$device/capacity") or die "Can't open  /proc/ide/$device/capacity: $!\n";
$bla=<FILE>;
close(FILE);

open(HDA, "/dev/hda");
seek(HDA,0,2);
$hdasize=tell HDA;
printf "Drivesize: %.2f GB\n",$hdasize/1024/1024/1024;

open(MODEL, "/proc/ide/$device/model") or die "Error!! Can't open file: /proc/ide/$device/model\n";
$model=<MODEL>;
close(MODEL);


$a=( $bla / 1953) / 1024;
$b=int $a;
if ( $b > 60 ) { $gb=5; }

$hdasize=$hdasize / 1024 / 1024 /1024;

chomp $model;
print "\nModel: $model";
printf "\nDrive size: %.2f GB\n", $hdasize;


$zeit = ( ( $hdasize / $gb ) * $sec ) * 4;
$mzeit=$zeit / 60;

printf "\nTime Min.: %.1f", $mzeit;

printf "\nTime Sec: %d\n\n", $zeit; 

$prefix= &speichern("Drive");

$sfile="$myhome/results/Drive/$hostname $model\_$prefix";

print "\nRunning Drive Benchmark....\n";
print "\nresult: $sfile\n";

$retval = fork();
if ($retval == -1) {
    die "fork() failed: $!\n";
} elsif ($retval == 0) {
    system("bin/piozone -t $gb /dev/$device $sec >/dev/null"); 
    if  ($? != 0) { print "Aborting!\n"; unlink("linear.txt"); unlink("random.txt"); print "\r"; exit 1 }    
     exit 0;
} else {
     for ($i=$zeit; $i>=0; $i--) { sleep 1; print "\e[2K]"; printf "Noch verbleibende Zeit (Sekunden): %d\r", $i; } ;
     wait();
}


#------------------------------------ Sorter Linear ---------------------------------------------------------------

open(SMALL, "<linear.txt") or die "Error! can't open file linear.txt\n";
unlink ("$sfile");
@b=<SMALL>;
close(SMALL);

$B=@b;
$suchwort="1024";
$suchwort2="64";

$i=0;
$a=0;
$sum1024=0;
$sum64=0;

for ($h=0; $h<$B; $h++)
{
	if ($b[$h] =~m/$suchwort/) {
	@z=split /MB/, $b[$h];
	$f[$i]=sprintf $z[0];
	$sum1024+=$z[0];
	$i++;
	}
	elsif ($b[$h] =~m/$suchwort2/) {
	@d=split /MB/, $b[$h];
	$g[$a]=sprintf $d[0];
	$sum64+=$d[0];
	$a++;
	}
	
}


@e=sort(@f);
$h=@f;
@e=sort(@g);
$h=@e;

open(RESULT, ">>$sfile") or die "Error! can't open file: $myhome/results/piozone/$sfile\n";

print RESULT "\n\t  $hostname:\t\n";
print RESULT "\n\t$model $b GB\t\n";
print RESULT "\n\t LINEAR MB/s:\t\n";
print RESULT "\t -----------\t\n\n";

print RESULT "\t    1024:\t\n";
print RESULT "\t(Min./Avg./Max.)\n";
print RESULT "\t $e[0]"; 
printf RESULT "%d ", $sum1024/$i;
print RESULT " $e[-1]  \n\n";

print RESULT "\t     64k:\t\t\n";
print RESULT "\t(Min./Avg./Max.)\n";
print RESULT "\t $e[0]";
printf RESULT " %d ", $sum64/$i;
print RESULT " $e[-1]  \n";

close(RESULT);


#---------------------------------------------------------------------------------------------------------------------





#--------------------------------------------- Sorter Random ---------------------------------------------------------


open(SMALL, "random.txt") or die "Error! can't open random.txt\n";
@b=<SMALL>;
$B=@b;
$suchwort="1024 KiB";
$suchwort2="64";

$i=0;
$a=0;
$sum64=0;
$sum1024=0;

for ($h=0; $h<$B; $h++)
{
	if ($b[$h] =~ /$suchwort/) {
	@z=split /MB/, $b[$h];
	$f[$i]=sprintf $z[0];
	$sum1024+=$z[0];
	$i++;
	}
	elsif ($b[$h] =~ /$suchwort2/) {
	@d=split /MB/, $b[$h],2;
	$g[$a]=sprintf $d[0];
	$sum64+=$d[0];
	$a++;
	}
}



open(RESULT, ">>$sfile") or die "Error! Can't open file: $myhome/results/piozone/$sfile\n";

print RESULT "\n\n\t RAMDOM MB/s:\t\n";
print RESULT "\t -----------\t\n\n";

@e=sort(@f);
$h=@f;
print RESULT "\t    1024K:\t\n";
print RESULT "\t(Min./Avg./Max.)\n";
print RESULT "\t $e[0] ";
printf RESULT "%d ", $sum1024/$i;
print RESULT "  $e[-1] \n";


print RESULT "\n\t     64k:\n";
@z=sort(@g);
$h=@z;
print RESULT "\t(Min./Avg./Max.)\n";
print RESULT "\t $z[0] ";
printf RESULT "%d ", $sum64/$a;
print RESULT " $z[-1] \n";

close(SMALL);
close(RESULT);

unlink("linear.txt");
unlink("random.txt");


@show=("less", "$sfile");
system(@show);

}

##################################################################################################################################



###################################################### Filesystem Benchmark #######################################################

sub fs {

sub kilbo {
$SIG{INT} = \&kilbo;
print "User abort\n";
unlink<$tmpdir/*>;
exit 0;
}

local $SIG{INT} = \&kilbo;


#--------------------------------- get ramsize ------------------------------------------------
open(MEM, "</proc/meminfo") || die "Cant open /proc/meminfo\n";
@test=<MEM>;
close(MEM);
foreach $i (@test) { if ($i =~ MemTotal) { $firstline=$i }; }
@lines=$firstline=~/[0-9]*/g;
$b=sprintf "@lines\n";
$b=~ s/ //ig;
$b=$b / 1024;
$ramsize=int $b;
#-----------------------------------------------------------------------------------------------


if (! -d "$myhome/.tmp") { mkdir "$myhome/.tmp";}

$bo="$myhome/.tmp";
$bonniesize=$ramsize * 2;
$bonnie=0;

@ver=split(/:/, $ENV{PATH} );

for $i (@ver) {

  opendir(DIR, "$i");
     @dir = readdir(DIR);
  close(DIR);

  $a=grep {/bonnie\++/} @dir;

   if ( $a == 1) { $bonniepath="$i/bonnie++"; $bonnie=1; print "\nbonnie++ found: $i/bonnie++\n"; last };
   }


if ( $bonnie != 1 ) { print "\nbonnie++ not found, path: @ver\n - using precompiled binary (/usr/bin/xfbsuite/bin/bonnie++)\n"; } else { $bonnie=0}



open(FS, "/etc/mtab") || die "Can't open /etc/mtab\n";
$f=<FS>;
@a=split( / /, $f);
$fs=$a[2];

chomp $fs;

$prefix= &speichern("Filesystem");
$sfile="$myhome/results/Filesystem/$hostname\ $fs\_$prefix";

print "\nRunning Filesystem Benchmark....\n";
print "\nresult: $sfile\n\n";

open(BONNIE, ">$sfile") || die "Can't open Bonnie Result File\n"; 
print BONNIE "Ram: $ramsize MB\n";

if ($username eq "root") { $userid="-u 0"} else {$userid="";}

system("$bonniepath -d $bo -s $bonniesize $userid -f -q > $tmpdir/tmp.txt 2>&1");
if  ($? != 0) { print "Aborting!\n"; unlink("$tmpdir/tmp.txt"); unlink("$bo/*"); exit 1 } 

open(TMP, "$tmpdir/tmp.txt") || die "Can't open Bonnie tmp File\n";
@temp=<TMP>;
foreach	(@temp) { print BONNIE $_ };

close(BONNIE);
unlink("$tmpdir/tmp.txt");

@show=("less", "$sfile");
system(@show);

}

########################################################################################################################################



############################################################# CPU ######################################################################

sub cpu {

sub kilnb {
$SIG{INT} = \&kilnb;
print "User abort\n";
unlink<$tmpdir/*>;
kill 15, $nbenchpid;
kill 9, $nbenchpid;
exit 0;
kill 9, $$;

}

local $SIG{INT} = \&kilnb;


#--------------------------------------- Get CPU Model and MHz -----------------------
open(CPU, "/proc/cpuinfo") || die "can't open /proc/cpuinfo\n";
@test=<CPU>;
close(CPU);
foreach $i (@test) { if ($i =~ "model name") {$firstline=$i} };
foreach $i (@test) { if ($i =~ "cpu MHz") {$secondline=$i} };
@bla=split(/:/, $firstline);
@bla2=split(/:/, $secondline);
#---------------------------------------------------------------------------------------

$cpumodel=sprintf $bla[1];
$cpuMHz=sprintf $bla2[1];
chomp $cpumodel;
chomp $cpuMHz;
$cpumodel=substr($cpumodel, 1, 100);
$cpuMHz=substr($cpuMHz, 1, 100);
$prefix= &speichern("Cpu");
$sfile="$myhome/results/Cpu/$hostname\ $cpumodel\ $cpuMHz\_$prefix";


print "\nRunning CPU Benchmark....\n";
print "\nresult: $sfile\n";

$nbenchpid=fork();
if ($nbenchpid == -1) { die "Error! can't fork\n"; }

elsif ($nbenchpid == 0 ) {

  exec("$nbench > $tmpdir/nbench.txt") || die "Can't execute $myhome/bin/nbnech\n";
}
else {
  while ( ! waitpid ($nbenchpid, &WNOHANG) ) {
 # print "...."; sleep 1;
  }
}



open(Result, ">$sfile") || die "Can't open result file ($myhome/results/nbench/...)!\n";
print Result "$cpumodel @ $cpuMHz\n-------------------------------------\n";
close(Result);

unlink("$tmpdir/nbench.txt");
@show=("less", "$sfile");
system(@show);

}


##########################################################################################################################################


############################################################ Cache ###############################################################

sub cache {

#---------------------------------------- Cachesize--------------------------------

open(CACHE, "/proc/cpuinfo") || die "Can't open /proc/cpuinfo!\n";
@test=<CACHE>;
close(CACHE);

foreach $i (@test) { if ($i =~ "cache size") {$cacheline=$i} };
@cache=split(/:/, $cacheline);

$cachesize=sprintf "$cache[1]";
chomp $cachesize;
$cachesize=substr($cachesize, 1, 100);

#----------------------------------------------------------------------------------

$a=$cachesize; $cachesize=~s/KB//g; $cachesize=~s/ //g;
$prefix= &speichern("Cache");
$sfile="$myhome/results/Cache/$hostname L2Cache:\ $cachesize\ KB\_$prefix";

print "\nRunning Cache Benchmark....\n";
print "result: $sfile\n";

open(CACHE, ">$sfile");
print CACHE "$hostname\t\n\n";
print CACHE "L2-Size: $cachesize\t\n";
print CACHE "--------\t\n"; 
print CACHE "Read Test:\t\n\nSize: MB/s\t\n";

system( "$cachebench -r -x1 -m10 -d1 -e1 >$tmpdir/tmpfile.txt" );
if  ($? != 0) { print "Aborting!\n"; unlink("$tmpdir/tmpfile.txt"); exit 1 } 

$zahl1=128;
open(TMP, "$tmpdir/tmpfile.txt"); @tmp=<TMP>; close(TMP);
for ($i=0; $i<5; $i++) { @a=split(/\./, $tmp[$i]); $a[0]=~s/.* //g;  $zahl1+=128; print CACHE "$zahl1: $a[0]\t\n"; }


print CACHE "\nWrite Test:\t\n\nSize: MB/s\t\n";

system("$cachebench -w -x1 -m10 -d1 -e1 >> $tmpdir/tmpfile.txt");
if  ($? != 0) { print "Aborting!\n"; unlink("$tmpdir/tmpfile.txt"); exit 1 } 

$zahl2=128;
open(TMP, "$tmpdir/tmpfile.txt"); @tmp2=<TMP>; close(TMP);
for ($i=5; $i<10; $i++) { @a=split(/\./, $tmp2[$i]); $a[0]=~s/.* //g; $zahl2+=128; print CACHE "$zahl2: $a[0]\t\n"; } 
close(TMP);

close(CACHE);
unlink("$tmpdir/tmpfile.txt");
@show=("less", "$sfile");
system(@show);


}

######################################################################################################################################

################################################### RAM ##############################################################################

sub ram {

#--------------------------------- get ramsize ------------------------------------------------
open(MEM, "</proc/meminfo") || die "Can't open /proc/meminfo!\n";
@test=<MEM>;
close(MEM);
foreach $i (@test) { if ($i =~ MemTotal) { $firstline=$i }; }
@lines=$firstline=~/[0-9]*/g;
$b=sprintf "@lines\n";
$b=~ s/ //ig;
$b=$b / 1024;
$ramsize=int $b;
#-----------------------------------------------------------------------------------------------------------------------------

$prefix= &speichern("Ram");
$sfile="$myhome/results/Ram/$hostname RAM: $ramsize MB_$prefix";

open(RAM, ">$sfile");
print RAM "$hostname\t\n";
print RAM "RAM: $ramsize\t\n";
print RAM "\n*** MB/s ***\t\n";

print "\nRunning Ram Benchmark....\n";
print "\nresult: $sfile\n";

system("$stream > $tmpdir/stream.txt") ;
if  ($? != 0) { print "Aborting!\n"; unlink("$tmpdir/stream.txt"); exit 1 } 

open(STREAM, "<$tmpdir/stream.txt") or die "Error! Can't open stream.txt\n";
@stream=<STREAM>;
close(STREAM);


@a=split(/ /, $stream[18]); $a[0]=~s/ //g;  print RAM "$a[0]\t\n";
@a=split(/\./, $stream[19]); $a[0]=~s/ //g; $a[0]=~s/.*://g; print RAM "Copy:  $a[0]\t\n";
@a=split(/\./, $stream[20]); $a[0]=~s/ //g; $a[0]=~s/.*://g; print RAM "Scale: $a[0]\t\n";
@a=split(/\./, $stream[21]); $a[0]=~s/ //g; $a[0]=~s/.*://g; print RAM "Add:   $a[0]\t\n";
@a=split(/\./, $stream[22]); $a[0]=~s/ //g; $a[0]=~s/.*://g; print RAM "Triad: $a[0]\t\n";
close(RAM);

unlink("$tmpdir/stream.txt");

@show=("less", "$sfile");
system(@show);

}

########################################################################################################################################


############################################################### X11 2D ###############################################################

sub x11 {

open(X, "/var/log/XFree86.0.log") || die "Error! can't open file: /var/log/XFree86.0.log!\n";
@x11=<X>;
close(X);
@temp=grep(/Version/, @x11);
@temp2=split(/ /, $temp[0]);
$Version=$temp2[2];
chomp $Version;
$username=$ENV{LOGNAME};
$prefix= &speichern("2D");
$sfile="$myhome/results/2D/$hostname\ X11\ Version:\ $Version\ _ $prefix";

print "\nRunning X11 2D Benchmark....\n";
print "\nresult: $sfile\n";

system("x11perf -repeat 1 -dot -line100 -rect100 -circle100 -scroll100 -shmput100 -ftext > $tmpdir/x11perf.log");
if  ($? != 0) { print "Aborting!\n"; unlink("$tmpdir/x11perf.log"); exit 1 } 

open(BLA, "$tmpdir/x11perf.log") or die "Error! Can't open $tmpdir/x11perf.log!\n";
@tmp=<BLA>;
close(BLA);

open(RESULT, ">$sfile") or die "Error! can't open result file: $sfile\n";

for ($i=7; $i<20; $i=$i+2) 
{ 
	$wo = index($tmp[$i], "msec"); $wo=$wo+5; $bla = substr($tmp[$i], $wo, 1000); print RESULT "$bla\n";
}


unlink("$tmpdir/x11perf.log");
print "$sfile\n";

@show=("less", "$sfile");
system(@show);


}

##########################################################################################################################################
