#!/bin/bash


set -m 

trap 'echo "stopp!"; rm -f *.txt; exit 0' 2 5


if [ -d results ]; then echo ; else mkdir results; fi


a=`type -p Xdialog`
aw=`type -p awk`
sd=`type -p sed`
gr=`type -p grep`
bonnie=`type -p bonnie++`

sleepversion=0
ver=`sleep --version |head -n 1|cut -d " " -f 4`
echo "$ver" |grep -q -E '[5-].[2-].*'
if ! [ $? = 0 ]; then export sleepversion=1; fi

export ramsize=$( echo "`cat /proc/meminfo |grep -i "MemTotal"| awk '{print $2}'` / 1024"|bc )
export bonniedir="/tmp/"
export bonniefree="`df -m /tmp |tail -n 1|awk '{print $4}'`"
export fs="`cat /etc/mtab |head -n 1|cut -d " " -f 3`"

if ! [ -d results/Cpu ]; then mkdir -p results/Cpu; fi
if ! [ -d results/Ram/details ]; then mkdir -p results/Ram/details; fi
if ! [ -d results/Cache ]; then mkdir results/Cache; fi
if ! [ -d results/Filesystem ]; then mkdir results/Filesystem; fi
if ! [ -d results/Drive/details ]; then mkdir -p results/Drive/details; fi
if ! [ -d results/2D ]; then mkdir results/2D; fi

if [ -z $gr ]; then -e "\nError!! You need grep - get it from: http://www.gnu.org/software/grep/grep.html"; exit 1; fi
if [ -z $sd ]; then - e "\nError!! You need sed - get it from: http://www.gnu.org/software/sed/sed.html"; exit 1; fi
if [ -z $aw ]; then echo -e "\nError!! You need awk - get it from: http://www.gnu.org/software/gawk/gawk.html\n"; exit 1; fi

if ! [ -e bin/stream ]; then Xdialog --clear --msgbox "Warning!!No Ram test Programm found (ram)!!" 0 0 ; fi
if ! [ -e bin/nbench ]; then Xdialog --clear --msgbox "Warning!! No CPU test Programm found (nbench)!!" 0 0; fi
if ! [ -e bin/piozone ]; then Xdialog --clear --msgbox "Warning!! No HDD test Programm found (piozone)!!" 0 0; fi
if ! [ -e bin/cachebench ]; then Xdialog --clear --msgbox "Warning!! No Cache test Programm found (cachebench)!!" 0 0; fi




function error () {

if [ $? -eq 130 ]; then echo "user aborted!"; $1; exit 1; fi
}


function error2 () {

{ echo -e "User aborted - or another error!\n"; $1; exit 1; }

}



function show () {

mark="$2"
resultfile="results/$mark/$HOSTNAME*"

if [ "$3" = a ]; then resultfile="all.$HOSTNAME"; fi

if [ $1 = x ]; then 

  Xdialog --clear --no-cancel --title "$mark Results" --textbox $resultfile 0 0 || error2
  frage
 elif [ $1 = t ]; then $PAGER $resultfile || error2; exit 1
 elif [ $1 = d ]; then dialog --clear --no-cancel --title "$mark Results" --textbox $resultfile 0 0 || error2
 elif [ $1 = no ]; then  true;  
 fi
}




function points () {

while [ true ]; 
   do 
      sleep 1;
      echo -n "."
      if [ -z `pidof "$1"` ]; then break; fi
   done
}



function secpoints () {

i=$1
xse=$2
ai=6
#i=$(($i - 2))

while ! [ "$i" = 0 ]
   do      
           
	   i=`echo "scale=2; $i - $xse"|bc -l`
	   b=`echo $i |cut -d "." -f 1`
	   ai=$((ai + 1))
	   sleep $xse
	   if [ -z `pidof piozone` ]; then break; fi
           if [ "$3" = t ]; then clear; echo "
	   Total Time Sec: $b
	   Drive Size: $iz GB
	   Ready: $ai% "; else echo "$ai"; fi
	   
   done
}



function waitgui () {

Xdialog --title "wait..." --infobox "Please wait...." 0 0 5000 &
}


function tauswahl () {
a="`type -p cat`"
l1="`type -p less`"
 
if [ -z $l1 ]; then PAGER=$a
else PAGER=$l1
fi
 

 function thelp () {
 

echo -e "\nfBenchmark Suite"
echo    "------------------"

echo -e "\nThe Options are:"
echo -e  "
          a    Make All Benchmarks (Ram, CPU, HDD, Cache, 2D)
          r    Ram 
          c    CPU
          p    HDD [device]
	  f    Filesystem	
          l    L1/L2 Cache
          x    X11 2D
	  h    This help"
}


par=$1

case $par in
	 a) all t;;
	 r) ram t;;
	 c) cpu t;;
	 p) hdbench t;;
	 f) fs t;;
	 l) cache t;;
	 x) myx11perf t;;
         h) thelp; exit 1;;
	 *) echo "Wrong Syntax!"; thelp; exit 1;;
esac

}



function dauswahl () {

a="`type -p dialog`"

if [ -z $a ]; then echo -e "\nCan't find dialog!! Not in your PATH?\n";exit;  fi

dialog --clear --title "fBenchmark Suite" --radiolist \
        'fBenchmark Suite' 0 0 0 \
	'1' 'ALL (Ram, CPU, HDD, Cache, 2D)' off \
	'2' 'Ram' on \
	'3' 'CPU' off \
	'4' 'HDD (Read Only)' off \
	'5' 'Filesystem' off \
	'6' 'L1/L2 Cache' off \
	'7' 'X11 2D' off 2> ~/tmp.sel
clear

answer=$(cat ~/tmp.sel)


for i in $answer; do
	case "$i" in
	1) all d;;
	2)  d;;
	3) cpu d;;
	4) hdbench d;;
	5) fs d;;
	6) cache d;;
	7) myx11perf d;;
	*) dialog --msgbox "No Benchmark selectet!" 0 0
	esac
done
}



function xauswahl () {

if [ -z $a ]; then echo -e "\nYou need Xdialog\n";exit;  fi

Xdialog --clear --title "fBenchmark Suite" --radiolist \
        'fBenchmark Suite' 0 0 0 \
	'1' 'ALL (Ram, CPU, HDD, Cache, 2D)' off \
	'2' 'Ram' on \
	'3' 'CPU' off \
	'4' 'HDD (Read Only)' off \
	'5' 'Filesystem' off \
	'5' 'L1/L2 Cache' off \
	'6' 'X11 2D' off 2> ~/tmp.sel

answer=$(cat ~/tmp.sel)


for i in $answer; do
	case "$i" in
	1) all x;;
	2) ram x;;
	3) cpu x;;
	4) hdbench x;;
	5) fs x;;
	6) cache x;;
	7) myx11perf x;;
	*) Xdialog --msgbox "No Benchmark selectet!" 0 0
	esac
done
}

if [ -f ~/tmp.sel ]; then rm ~/tmp.sel; fi


################################################ All Benchmarks ###########################################################


function all () {
echo "Testing all (RAM, X11, Cache, HDD, CPU)"

echo -e "\n Testing HDD Performance..."
hdbench no

echo -e "\n Testing Filesystem Performance...."
fs no

echo -e "\n Testing Cache Performance..."
cache no

echo -e "\n Testing Ram Performance..."
ram no

echo -e "\n Testing X11 2D Performance..."
myx11perf no

echo -e "\n Testing CPU Performance..."
cpu no







echo " " > results/all.$HOSTNAME

cd results

echo -e "\n***************************** CPU Benchmark: *******************************************" > all.$HOSTNAME
cat nbench/"nbench.$HOSTNAME.$cpumodel@$cpumhz MHz" >> all.$HOSTNAME

echo -e "\n***************************** Memory Benchmark: *******************************************" >> all.$HOSTNAME
cat ram/ram.$HOSTNAME >> all.$HOSTNAME

echo -e "\n***************************** Cache Benchmark: *******************************************" >> all.$HOSTNAME
cat cachebench/cache.$HOSTNAME  >> all.$HOSTNAME

echo -e "\n***************************** HDD Benchmark: *******************************************" >> all.$HOSTNAME
cat Drive/Drive.$HOSTNAME.* >> all.$HOSTNAME

echo -e "\n***************************** Filesystem Benchmark: *****************************************" >> all.$HOSTNAME
cat bonnie/bonnie.$HOSTNAME* >> all.$HOSTNAME

echo -e "\n***************************** X11 2D  Benchmark: *******************************************" >> all.$HOSTNAME
cat x11perf/x11perf.$HOSTNAME >> all.$HOSTNAME

show $1 all.$HOSTNAME a

}



################################################ HDD Benchmark ###############################################################


function hdbench () {

gb=2
sec=2
device="$2"

if [ -z "$device" ]; then device="/dev/hda"; fi

za="`echo $device|cut -d "/" -f 3`"

ih=`cat /proc/ide/$za/capacity`
hddspace=`echo $(($ih / 1953))`
iz=`echo $(($hddspace / 1024 ))`


if [ $iz -gt 59 ]; then gsp=5; else gsp=2; fi

zeit=`echo "( ($iz / $gsp) * $sec ) * 4" |bc`
mzeit=`echo "scale=1; "$zeit / 60 | bc -l`
xzeit=`echo "scale=2; $zeit / 100"|bc -l`

skill piozone

if [ $sleepversion -eq 1 ]; then echo -e "\nYou don't have the right Version of sleep (Version > 0.5.2 needed) - you don't get a Progressbar!\n"; echo -e "\nDrive Size: $iz GB
Total Time: $mzeit Min."; points Drive || error2 &

 elif [ $1 = d ]; then secpoints $zeit $xzeit & 

 elif [ $1 = t ]; then secpoints $zeit $xzeit t || error2 &

 elif [ $1 = x ]; then secpoints $zeit $xzeit | Xdialog --title "Estimated Min: $mzeit" --backtitle "Drive Size: $iz GB" --gauge "Please wait..." 0 0 || error2 &

 elif [ $1 = no ]; then points Drive || error2 &

fi


bin/piozone -v -t 2 $device $gsp | sed -n '1,4d' || error2 "skill piozone"
 
echo -e "\nReady\n"; clear
   
   
function average () {

a=0
c=0
b=0
d=0

grep -E '64' linear.txt > 64klinear.txt
grep -E '1024' linear.txt > 1024klinear.txt

model="`cat /proc/ide/hda/model`"

awk '{print $1}' 64klinear.txt > .64kline
awk '{print $1}' 1024klinear.txt > .1024kline

###### for 64k ######

echo -e "\t$HOSTNAME $model $1 GB\n" >> Drive_results.txt

echo -e "\n\tLinear Read Test 64k/1024k:" >>  Drive_results.txt
echo -e "\t---------------------------" >>  Drive_results.txt

while read i; do a=`echo "$a + $i"|bc`; done < .64kline

c=`cat .64kline | wc -l`

durchschnitt=`echo "scale=2; ($a / $c)" |bc -l `


d=`echo $durchschnitt |cut -d "." -f 1`

echo -e "\n\t\t\t64K:"  >> Drive_results.txt


Min=`cat .64kline |sort -ng -k1 |head -n 1`
Max=`cat .64kline |sort -ng -k1 |tail -n 1`


echo -e "\tMin=$Min   Avg=$durchschnitt  Max=$Max\n" >> Drive_results.txt


##### for 1024k #######

a=0
c=0
b=0
durchschnitt=0
d=0

while read i; do a=`echo "$a + $i"|bc`; done < .1024kline

c=`cat .64kline | wc -l`

durchschnitt=`echo "scale=2; ($a / $c)" |bc -l `

d=`echo "$a / $c" |bc`


echo -e "\n\t\t\t1024K:" >> Drive_results.txt


Min=`cat .1024kline |sort -ng -k1 |head -n 1`
Max=`cat .1024kline |sort -ng -k1 |tail -n 1`


echo -e "\tMin=$Min   Avg=$durchschnitt  Max=$Max\n" >> Drive_results.txt


##### Random #####

a=0
c=0
durchschnitt=0
d=0
b=0

echo -e "\n\n\tRandom  Read Test 64k/1024k:" >>  Drive_results.txt
echo -e     "\t----------------------------" >>  Drive_results.txt

grep -E '64' random.txt > 64krandom.txt
grep -E '1024' random.txt > 1024krandom.txt

awk '{print $1}' 64krandom.txt > .64krline
awk '{print $1}' 1024krandom.txt > .1024krline


#### for 64k #####
while read i; do a=`echo "$a + $i"|bc`; done < .64krline

c=`cat .64krline | wc -l`

durchschnitt=`echo "scale=2; ($a / $c)" |bc -l`

d=`echo "$a / $c" |bc`

echo -e "\n\t\t\t64k:" >> Drive_results.txt


Min=`cat .64krline |sort -ng -k1 |head -n 1`
Max=`cat .64krline |sort -ng -k1 |tail -n 1`


echo -e "\tMin=$Min    Avg=$durchschnitt   Max=$Max\n" >> Drive_results.txt


##### for 1024k #######
a=0
c=0
durchschnitt=0
d=0
b=0

while read i; do a=`echo "$a + $i"|bc`; done < .1024krline

c=`cat .1024krline | wc -l`

durchschnitt=`echo "scale=2; ($a / $c)" |bc -l`

d=`echo "$a / $c" |bc`


echo -e "\n\t\t\t1024k:" >> Drive_results.txt


Min=`cat .1024krline |sort -ng -k1 |head -n 1`
Max=`cat .1024krline |sort -ng -k1 |tail -n 1`


echo -e "\tMin=$Min   Avg=$durchschnitt  Max=$Max\n" >> Drive_results.txt


if ! [ -d results/Drive/details ]; then mkdir results/Drive/details; fi
 
mv linear.txt results/Drive/details/Drive_linear.txt
mv random.txt results/Drive/details/Drive_random.txt
mv Drive_results.txt results/Drive/"$HOSTNAME $model $1_GB"

rm -r .64kline .1024kline .64krline .1024krline 64klinear.txt 1024klinear.txt 64krandom.txt 1024krandom.txt

}

average

sleep 1

show $1 Drive

}

############################################# Filesystem Benchmark ########################################################

function fs () {

sfile=results/Filesystem/"$HOSTNAME $fs"
f=`echo "$ramsize * 2"|bc`
di="/tmp/BONNIE_OUTPUT"


if ! [ -d $di ]; then mkdir $di; fi
if [ $bonniefree -le $f ]; then echo -e "\n Error!! not enought space for bonnie++ Filesystem Test - we need least of $bonniefree MB free\n - You can easy change the bonnie++ output dir - at the beginn of this Script you have a bonniedir Variable (its set to /tmp)."; exit 1; fi
if [ -z $bonnie ]; then { $bonnie="bin/bonnie++"; $echo -e "\nInfo! Bonnie++ not found! using binary at \"./bin/bonnie++\" You can download bonnie++ from: http://www.coker.com.au/bonnie++/\n";} fi

skill "bonnie++"

echo -e "\n $HOSTNAME Ram: $ramsize MB  $fs \n" > "$sfile"

$bonnie -d $di -s $f -u 0 -f -q >> "$sfile" 2>&1 
if [ $? = 5 ]; then echo -e "\nUser aborted"; kill %1; exit 1; fi
 
echo "Ready"

show $1 Filesystem

}
############################################# CPU Benchmark #############################################################

function cpu () {

cpumodel="`grep -i "model name" /proc/cpuinfo| cut -d ":" -f 2 |tr -d " " `"
cpumhz="`grep -i "MHz" /proc/cpuinfo| cut -d ":" -f 2 |tr -d " "`"

sfile=results/Cpu/"$HOSTNAME.$cpumodel@$cpumhz MHz"

if [ $1 = x ]; then waitgui; fi

skill nbench

points nbench || error2 &

echo -e "$HOSTNAME $cpumodel $cpumhz" > "$sfile" 

bin/nbench > nbench.txt || error2


cat nbench.txt |sed '27d'|sed '2,4d'|sed '16,19d'|sed '24,25d' >> "$sfile"

rm nbench.txt

show $1 Cpu

}

################################################# Cache Benchmark: #########################################################


function cache () {

cachesize="`grep -i "cache size" /proc/cpuinfo |cut -d ":" -f2`"

sfile=results/Cache/"$HOSTNAME L2_Cachesize: $cachesize"

if [ $1 = x ]; then waitgui; fi

skill cachebench

points cachebench || error2 &

echo -e "$HOSTNAME L2-Cache: $cachesize " > "$sfile"

echo -e "\ndouble Read Cache Test" >> "$sfile"
echo -e "\nC-Size MB/sec" >> "$sfile"

bin/cachebench -r -x1 -m10 -d1 -e1 | cut -d "." -f 1 >> "$sfile" || error2

echo -e "\ndouble Write Cache Test" >> "$sfile"
echo -e "\nC-Size MB/sec" >> "$sfile"

bin/cachebench -w -x1 -m10 -d1 -e1 | cut -d "." -f 1 >> "$sfile" || error2
echo -e "\r"

show $1 Cache

}

################################################### Memory Benchmark  #########################################################


function ram () {

sfile=results/Ram/"$HOSTNAME $ramsize MB"

if [ $1 = x ]; then waitgui; fi

skill stream

echo -e "$HOSTNAME $ramsize MB\t" > "$sfile"
bin/stream > ram.txt || error2

echo -e "\t*** MB/s ***\n" >> "$sfile"

cat ram.txt |tail -n 4 |awk '{print "\t"$1"\t"$2}' | cut -d "." -f 1 >> "$sfile"
mv ram.txt results/Ram/details/ram_fulloutput.$HOSTNAME

show $1 Ram 

}

################################################# X11 2D Benchmark  #############################################################


function myx11perf () {

Version="`grep -i "XFree86 Version" /var/log/XFree86.0.log | cut -d " " -f 3`"
sfile=results/2D/"$HOSTNAME ver: $Version"
echo -e "\t$HOSTNAME X Version: $Version\t\n" > "$sfile"

a=`type -p x11perf`
if [ -z $a ]; then echo "\nError!! - can't find x11perf - not in your Path?\n"; exit 1; fi

skill x11perf

x11perf -repeat 1 -dot -line100 -rect100 -circle100 -scroll100 -shmput100 -ftext >> x11perf.log || error2


cat x11perf.log |awk -F "msec" '{print $2}'|tr -d "(" |tr -d " "|sed -e 's/)/ /g'|sed '/^$/d'|sed '1d'  >> out.txt
while read zeile; do echo -e "\t$zeile\t" >> "$sfile"; done < out.txt
rm -f x11perf.log out.txt


show $1 2D

}

################################################ frage ###################################################################


function frage () {

Xdialog --title "Question" --yesno "More Benchmarks?" 0 0
 if [ $? = 0 ]; then      
    xauswahl
 else
  exit 1;
 fi
}


##################################################### Main  ##########################################################


while [ "$#" -gt 0 ]; do 
   case $1 in
      -h) # we need help?      
         echo "Parameter:
	  -t Textversion [parameter]
	  -d dialog (ncurses)
	  -x Xdialog
	  -h help"
	  shift;;
      -t) # Text Version
         tauswahl $2
	 shift;;
      -x) # Xdialog
      	  xauswahl
	  shift;;
      -d) # Dialog
           dauswahl
	   shift;;
      *) # Unbekannte Option
         echo "Please call help: xfbsuite -h"
	 shift;;
      ?) # Unbekannte Option
         echo "Please call help: xfbsuite -h";;
	 
         
   esac
done
#######################################################################################################################

